// TuttěvZ
#include <LEDA/graph/graph.h>
#include <LEDA/graph/node_array.h>
#include <LEDA/core/array.h>
#include <iostream>
#include <cmath>
#include <LEDA/graph/graph_alg.h>
#include <LEDA/numbers/integer.h>

using namespace leda;
using namespace std;

array<edge> a(100);
array<edge> s(100);
graph G;       // Ot
int n;         // _
int m;         // Ӑ
integer su = 0,su2 = 0;
int x;         // tutte̕ϐP
int y;         // tutte̕ϐQ
int r = 11;    // F
int N;         // OtG̘A
integer **T;   // TuttěWzւ̃|C^

void subset(int, int);
void print_subset(int);
void tutte(int);
void tutte_coe(int, int);
integer kaijo(int);
integer pow_int(int, int);
void chr_p();
integer combi(int, int);

int main()
{
  G.read("graph2.gw");

  n = G.number_of_nodes();
  m = G.number_of_edges();

  node_array<int> comp_num(G);
  N = COMPONENTS(G, comp_num);

  x = 1-r;
  y = 0;

  int i = 0;
  edge e;
  forall_edges(e, G){
    a[i] = e;
    i++;
  }
  
  T = new integer*[n-N+1];
  for(i = 0; i <= n-N; i++)
    T[i] = new integer[m-(n-N)+1];
  
  for(i = 0; i <= n-N; i++)
    for(int j = 0; j <= m-(n-N); j++)
      T[i][j] = 0;
  
  subset(0, 0);

  for(i = 0; i <= n-N; i++){
    for(int j = 0; j <= m-(n-N); j++)
      cout << T[i][j] << " ";
    cout << endl;
  }
  
  chr_p();
  
  cout << "su=" << su << endl;
  cout << "su2=" << su2 << endl;
  
  for(i = 0; i <= n-N; i++)
    delete [] T[i]; 
  delete [] T;
  return 0;
}

void subset(int i, int h) {
  if (i > m - 1) {
    tutte(h - 1);
  }
  else {
    subset(i + 1,h);
    s[h] = a[i];   subset(i + 1, h + 1);
  }
}

void tutte(int l) {
  int i;
  for (i = 0; i <= l; i++) {
    G.hide_edge(s[i]);
  }
  node_array<int> comp_num(G);
  int N2 = COMPONENTS(G, comp_num);
  int m2 = G.number_of_edges();
  tutte_coe((n-N)-(n-N2), m2-(n-N2));
  su += pow_int(x-1, (n-N)-(n-N2)) * pow_int(y-1, m2-(n-N2));
  G.restore_all_edges();
}

void tutte_coe(int a, int b)
{
  int i, j;

  for(i = 0; i <= a; i++)
    for(j = 0; j <= b; j++)
      T[i][j] += ((combi(a, i)) * (pow_int(-1,a-i)))*
	((combi(b, j)) * (pow_int(-1,b-j)));
  
}

void chr_p(void)
{
  su *= pow_int(-1, n-N) * pow_int(r, N);
  int i, j;
  integer *P;

  P = new integer[n-N+1];
  for(i = 0; i <= n-N; i++)
    P[i] = 0;

  for(i = 0; i <= n-N; i++)
    for(j = 0; j <= i; j++)
      P[i-j] += combi(i,j) * pow_int(-1, i-j) * T[i][0];

  for(i = 0; i <= n-N; i++)
    P[i] *= pow_int(-1, n-N);

  cout << "chromatic polynomial" << endl;
  cout << "P(G;r) = ";
  for(i = 0; i <= n-N; i++){
    cout << P[i] << "r^" << i+N << ' ';
    if(i != n-N)
      cout << "+" << ' ';
    else cout << endl;
  }
  
  for(i = 0; i <= n-N; i++)
    su2 += P[i]*pow_int(r, i+N);
  
  delete [] P;
}

integer pow_int(int a, int b)
{
  int i;
  integer n = 1;

  for(i = 0; i < b; i++)
    n *= a;
  return n;
}

integer combi(int n, int k)
{
  return kaijo(n)/(kaijo(n-k)*kaijo(k));
}

integer kaijo(int a)
{
  int i;
  integer n = 1;
  
  for(i = 2; i <= a; i++)
    n *= i;
  return n;
}
